package com.example.gajz.transferrelationship.relationalalgorithm;
import com.example.gajz.transferrelationship.bean.param.Dot;
import com.example.gajz.transferrelationship.bean.vo.SearchRelationshipVo;
import com.example.gajz.transferrelationship.neo4j.Colour;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

/**
 * 转账关系图
 */
public class RelationalAlgorithm {

    /**
     * 转账关系图  关系图搜索   展示图算法
     */
    public List searchPresentation(List<SearchRelationshipVo> searchRelationshipVos){
        /**----------------------------公共使用值------------------------------*/
        /**存放中心点list*/
        List<Dot>  centerPointList=new ArrayList<>();
        /**已经存在的点 会存储到map里面*/
        HashMap hashMap=new HashMap();
        //查询转账人(中心点)信息
        List list=new ArrayList();
        int centerPointX = 0;
        int centerPointY = 0;
        //存储所有大圆的四角X Y轴数据
        HashMap xyMap = new HashMap();
        /**---------------------------------------------------------------------*/
        /**将有下级的点存入中心点list集合中*/
        for (int i=0;i<searchRelationshipVos.size();i++){
            if (searchRelationshipVos.get(i).getSubordinate()){
                Dot dot=new Dot();
                dot.setId(searchRelationshipVos.get(i).getCardNumber());
                dot.setRelationship(searchRelationshipVos.get(i).getRelationship());
                dot.setName(searchRelationshipVos.get(i).getName());
                dot.setTransferTimes(searchRelationshipVos.get(i).getTransferTimes());
                dot.setRelationship(searchRelationshipVos.get(i).getRelationship());
                centerPointList.add(dot);
            }
        }
//        System.out.println("共有"+centerPointList.size()+"个中心点");

        /**循环中心点*/
            for (int i=0;i<centerPointList.size();i++){
                    //是否重叠
                    boolean overlap=false;
                    //生成颜色
                    Colour colour=new Colour();
                    String code=colour.getColour();
                    /**----------------------------中心点赋值------------------------------*/
                    Dot dot=new Dot();
                    dot.setId(centerPointList.get(i).getId());
                    int  position=1000;
                    if (searchRelationshipVos.size()>10000){
                        position=(searchRelationshipVos.size()/5);
                    }
                    dot.setX((int)(Math.random()*position));  //随机生成X轴
                    dot.setY((int)(Math.random()*position));  //随机生成Y轴
                    dot.setName(centerPointList.get(i).getName());
                    dot.setColor(code);
                    dot.setRelationship(centerPointList.get(i).getRelationship());
                    dot.setTransferTimes(centerPointList.get(i).getTransferTimes());
                    centerPointX=dot.getX();
                    centerPointY=dot.getY();
                    /**---------------------------------------------------------------------*/
                    /**----------------------------将中心点下级存入list中   获取中心点下级数据-----------------------------*/
                    /**将没有重复的值 存储到这个list里面*/
                    List<Dot> dataList=new ArrayList<>();

                    /**循环出中心点下级*/
                    for (int x=0;x<searchRelationshipVos.size();x++){
                        if (centerPointList.get(i).getId()==searchRelationshipVos.get(x).getRelationship()&&
                                !searchRelationshipVos.get(x).getSubordinate()){
//                            Object target = hashMap.get(searchRelationshipVos.get(i).getCardNumber());
//                            if (target==null){
                               Dot dot1=new Dot();
                                dot1.setName(searchRelationshipVos.get(x).getName());
                                dot1.setId(searchRelationshipVos.get(x).getCardNumber());
                                dot1.setTransferTimes(searchRelationshipVos.get(x).getTransferTimes());
                                dot1.setRelationship(searchRelationshipVos.get(x).getRelationship());
                                dataList.add(dot1);
//                                hashMap.put(searchRelationshipVos.get(x).getCardNumber(),searchRelationshipVos.get(x).getCardNumber());
//                            }
                        }
                    }
//                    System.out.println("卡号："+centerPointList.get(i).getId());
//                    System.out.println("下级数量："+dataList.size());
                    /**-------------------------------------------------------------------------------*/
                    /**
                     * 判断中心点大小
                     */
                    if (dataList.size()==0||dataList.size()<=100){
                        dot.setSize(2);
                    }else if (dataList.size()>=100){
                        dot.setSize(2);
                    }

                    /**每圈点数  动态变化 */
                    int base = 8;
                    /**总数*/
                    int total = dataList.size();
                    /**循环次数*/
                    int numberCycles =0;

                    /**  -----------------------计算大图四个角的XY轴代码-----------------------*/
                    /**算大圈半径专用    总数*/
                    int bigTotal = dataList.size();
                    /**算大圈半径专用   每圈点数*/
                    int bigBase = 8;
                    for (int n=1;bigTotal>0;n++){
                        bigTotal = bigTotal-bigBase;
                        bigBase = bigBase+20;
                    }
                    /** 大圆最后一圈半径  每份多少点数 */
                    int bigPointsPerShare = bigBase/4;
                    /**大圆最后一圈半径   相等于大圈半径   点数*距离 */
                    int fullCircleRadius =bigPointsPerShare*2;
                    /**  -------------------------------------------------------------------*/
                    if (i==0){
                        xyMap.put(i+"zX",(centerPointX-fullCircleRadius)); //圆左X轴
                        xyMap.put(i+"yX",(centerPointX+fullCircleRadius)); //圆右X轴
                        xyMap.put(i+"sY",(centerPointY-fullCircleRadius)); //圆上Y轴
                        xyMap.put(i+"xY",(centerPointY+fullCircleRadius)); //圆下Y轴
//                /** 将中心点X Y轴拼接 并存入Redis中*/
//                String position=test.getX()+"Y"+test.getY();
//                conn.set(test.getId(),position);
                        list.add(dot);
                        overlap=true;
                    }else {
                        for (int p=0;p<i;p++){
                            int zX = (int) xyMap.get(p + "zX");
                            int yX = (int) xyMap.get(p + "yX");
                            int sY = (int) xyMap.get(p + "sY");
                            int xY = (int) xyMap.get(p + "xY");
                            if(   ((zX>(centerPointX-fullCircleRadius)&&zX>(centerPointX+fullCircleRadius)) ||(yX<(centerPointX-fullCircleRadius)&&yX<(centerPointX+fullCircleRadius)))
                                    ||
                                    ((sY>(centerPointY-fullCircleRadius)&&sY>(centerPointY+fullCircleRadius)) ||(xY<(centerPointY-fullCircleRadius)&&xY<(centerPointY+fullCircleRadius)))   ){
                                if (p==i-1) {
                                    xyMap.put(i + "zX", (centerPointX-fullCircleRadius)); //圆左X轴
                                    xyMap.put(i + "zY", centerPointY); //圆左Y轴
                                    xyMap.put(i + "yX", (centerPointX+fullCircleRadius)); //圆右X轴
                                    xyMap.put(i + "yY", centerPointY); //圆右Y轴
                                    xyMap.put(i + "sX", centerPointX); //圆上X轴
                                    xyMap.put(i + "sY", (centerPointY-fullCircleRadius)); //圆上Y轴
                                    xyMap.put(i + "xX", centerPointX); //圆下X轴
                                    xyMap.put(i + "xY", (centerPointY+fullCircleRadius)); //圆下Y轴
                                    /** 将中心点X Y轴拼接 并存入Redis中*/
//                            String position=test.getX()+"Y"+test.getY();
//                            conn.set(test.getId(),position);
                                    list.add(dot);
                                    overlap=true;
                                }
                            }else {
                                overlap=false;
                                break;
                            }
                        }
                    }
                    if (!overlap){
                        i--;
                        continue;
                    }

                    /**圆圈层数  每循环一次 就是一圈*/
                    for (int y=1;total>0;y++){
                        /**点之间 x轴y轴间隔距离*/
                        int distance=2;
                        /**圆分成四份  每份多少点数*/
                        int pointsPerShare = base/4;
                        /**小圆半径  点数X距离*/
                        int circleRadius = pointsPerShare * distance;
                        /**右下角逐渐递减*/
                        int lowerRight = 0;
                        /**左下角逐渐递减*/
                        int lowerLeft  = 0;
                        /**左上角逐渐递减*/
                        int upperLeft = 0;
                        /**点大小*/
                        double pointSize =1;
                        if (base<=total){
                            for (int t=0;t<base;t++){
                                Dot test1=new Dot();
                                if (t<pointsPerShare){
                                    test1.setId(dataList.get(numberCycles).getId());
                                    test1.setName(dataList.get(numberCycles).getName());
                                    test1.setX((distance*t)+centerPointX);
                                    test1.setY((centerPointY-circleRadius)+(distance*t));
                                    test1.setColor(code);
                                    test1.setSize(pointSize);
                                    test1.setRelationship(dataList.get(numberCycles).getRelationship());
                                    test1.setTransferTimes(dataList.get(numberCycles).getTransferTimes());
                                }else if (t<=pointsPerShare*2){
                                    test1.setId(dataList.get(numberCycles).getId());
                                    test1.setName(dataList.get(numberCycles).getName());
                                    test1.setX((centerPointX+circleRadius)-(distance*lowerRight));
                                    test1.setY(centerPointY+(lowerRight*distance));
                                    test1.setColor(code);
                                    test1.setSize(pointSize);
                                    test1.setRelationship(dataList.get(numberCycles).getRelationship());
                                    test1.setTransferTimes(dataList.get(numberCycles).getTransferTimes());
                                    lowerRight++;
                                }else if (t<=pointsPerShare*3){
                                    test1.setId(dataList.get(numberCycles).getId());
                                    test1.setName(dataList.get(numberCycles).getName());
                                    test1.setX((centerPointX-circleRadius)+(distance*lowerLeft));
                                    test1.setY(centerPointY+(distance*lowerLeft));
                                    test1.setColor(code);
                                    test1.setSize(pointSize);
                                    test1.setRelationship(dataList.get(numberCycles).getRelationship());
                                    test1.setTransferTimes(dataList.get(numberCycles).getTransferTimes());
                                    lowerLeft++;
                                }else if (t<=pointsPerShare*4){
                                    test1.setId(dataList.get(numberCycles).getId());
                                    test1.setName(dataList.get(numberCycles).getName());
                                    test1.setX(centerPointX-(distance*upperLeft));
                                    test1.setY((centerPointY-circleRadius)+(distance*upperLeft));
                                    test1.setColor(code);
                                    test1.setSize(pointSize);
                                    test1.setRelationship(dataList.get(numberCycles).getRelationship());
                                    test1.setTransferTimes(dataList.get(numberCycles).getTransferTimes());
                                    upperLeft++;
                                }
//                        /** 将其他点 X Y轴拼接 并存入Redis中*/
//                        String position=test1.getX()+"Y"+test1.getY();
//                        conn.set(test1.getId(),position);
                                list.add(test1);
                                numberCycles++;
                            }
                            total=total-base;
                            base = base+20;
                            continue;
                        }
                        if (base>0){
                            for (int t=0;numberCycles<dataList.size();t++){
                                Dot test1=new Dot();
                                if (t<pointsPerShare){
                                    test1.setId(dataList.get(numberCycles).getId());
                                    test1.setRelationship(dataList.get(numberCycles).getRelationship());
                                    test1.setName(dataList.get(numberCycles).getName());
                                    test1.setX((distance*t)+centerPointX);
                                    test1.setY((centerPointY-circleRadius)+(distance*t));
                                    test1.setColor(code);
                                    test1.setSize(pointSize);
                                    test1.setTransferTimes(dataList.get(numberCycles).getTransferTimes());
                                }else if (t<=pointsPerShare*2){
                                    test1.setId(dataList.get(numberCycles).getId());
                                    test1.setRelationship(dataList.get(numberCycles).getRelationship());
                                    test1.setName(dataList.get(numberCycles).getName());
                                    test1.setX((centerPointX+circleRadius)-(distance*lowerRight));
                                    test1.setY(centerPointY+(lowerRight*distance));
                                    test1.setColor(code);
                                    test1.setSize(pointSize);
                                    test1.setTransferTimes(dataList.get(numberCycles).getTransferTimes());
                                    lowerRight++;
                                }else if (t<=pointsPerShare*3){
                                    test1.setId(dataList.get(numberCycles).getId());
                                    test1.setRelationship(dataList.get(numberCycles).getRelationship());
                                    test1.setName(dataList.get(numberCycles).getName());
                                    test1.setX((centerPointX-circleRadius)+(distance*lowerLeft));
                                    test1.setY(centerPointY+(distance*lowerLeft));
                                    test1.setColor(code);
                                    test1.setSize(pointSize);
                                    test1.setTransferTimes(dataList.get(numberCycles).getTransferTimes());
                                    lowerLeft++;
                                }else if (t<=pointsPerShare*4){
                                    test1.setId(dataList.get(numberCycles).getId());
                                    test1.setRelationship(dataList.get(numberCycles).getRelationship());
                                    test1.setName(dataList.get(numberCycles).getName());
                                    test1.setX(centerPointX-(distance*upperLeft));
                                    test1.setY((centerPointY-circleRadius)+(distance*upperLeft));
                                    test1.setColor(code);
                                    test1.setSize(pointSize);
                                    test1.setTransferTimes(dataList.get(numberCycles).getTransferTimes());
                                    upperLeft++;
                                }
//                        /** 将其他点 X Y轴拼接 并存入Redis中*/
//                        String position=test1.getX()+"Y"+test1.getY();
//                        conn.set(test1.getId(),position);
                                list.add(test1);
                                numberCycles++;
                            }
                            break;
                        }
                    }
                }

        return list;

    }



}
